dim objWMIService
dim managementService
dim fileSystem


const JobStarting = 3
const JobRunning = 4
const JobCompleted = 7
const wmiStarted = 4096
const wmiSuccessful = 0
const Saved = 32769

'VM Operational Status
const VMRunning = 2
const VMStopped = 10
const VMSaved = 15

Main()


'-----------------------------------------------------------------
' Main
'-----------------------------------------------------------------
Sub Main()
    set fileSystem = Wscript.CreateObject("Scripting.FileSystemObject")
    strComputer = "."
    set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\virtualization")
    GetManagmentServiceInstance
    set MyFirstVM = GetComputerSystem("YourVirtualMachineName")

    if ModifyVirtualSystem(MyFirstVM) then
        WriteLog "Done"
        WScript.Quit(0)
    else
        WriteLog "Failed"
        WScript.Quit(1)
    end if
End Sub


'-----------------------------------------------------------------
' Retrieve Msvm_VirtualSystemManagementService from WMI
'-----------------------------------------------------------------
Sub GetManagmentServiceInstance()
    query = "select * from Msvm_VirtualSystemManagementService"
    set managementService = objWMIService.ExecQuery(query).ItemIndex(0)
End Sub

'-----------------------------------------------------------------
' Retrieve Msvm_VirtualComputerSystem from base on its ElementName
' 
'-----------------------------------------------------------------
Function GetComputerSystem(vmElementName)
    On Error Resume Next
    query = Format1("select * from Msvm_ComputerSystem where ElementName = '{0}'", vmElementName)
    set GetComputerSystem = objWMIService.ExecQuery(query).ItemIndex(0)
    if (Err.Number <> 0) then
        WriteLog Format1("Err.Number: {0}", Err.Number)
        WriteLog Format1("Err.Description:{0}",Err.Description)
        WScript.Quit(1)
    end if
End Function

'-----------------------------------------------------------------
' Define a virtual system
'-----------------------------------------------------------------
Function ModifyVirtualSystem(computerSystem)

    ModifyVirtualSystem = false
    set objInParam = managementService.Methods_("ModifyVirtualSystem").InParameters.SpawnInstance_()
    
    query = Format1("ASSOCIATORS OF {{0}} WHERE AssocClass = Msvm_SettingsDefineState resultClass = Msvm_VirtualSystemsettingData", computerSystem.Path_.Path)
    set virtualSystemsetting = objWMIService.ExecQuery(query).ItemIndex(0)
    virtualSystemsetting.BIOSGUID = "{494BE480-0C2F-11DA-ABB6-72CC4387A395}"
    
    objInParam.ComputerSystem = computerSystem.Path_.Path
    objInParam.SystemsettingData = virtualSystemsetting.GetText_(1)
    
    set objOutParams = managementService.ExecMethod_("ModifyVirtualSystem", objInParam)

    if (WMIMethodStarted(objOutParams)) then
        if (WMIJobCompleted(objOutParams)) then
            ModifyVirtualSystem = true
        end if
    else
        if (wmiStatus = wmiSuccessful) then
            ModifyVirtualSystem = true
        else
            WriteLog Format1("DefineVirtualSystem failed with ReturnValue {0}", wmiStatus)
        end if
    end if

End Function

'-----------------------------------------------------------------
' Handle wmi return values
'-----------------------------------------------------------------
Function WMIMethodStarted(outParam)

    WMIMethodStarted = false

    if Not IsNull(outParam) then
        wmiStatus = outParam.ReturnValue
        WriteLog Format1("WMI API return code: {0}", wmiStatus)

        if  wmiStatus = wmiStarted then
            WMIMethodStarted = true
        end if

    end if

End Function


'-----------------------------------------------------------------
' Handle wmi Job object
'-----------------------------------------------------------------
Function WMIJobCompleted(outParam)
    dim WMIJob
    WMIJobCompleted = true

    set WMIJob = objWMIService.Get(outParam.Job)

    while jobState = JobRunning or jobState = JobStarting

        WScript.Sleep(1000)
        set WMIJob = objWMIService.Get(outParam.Job)

    wend

    if (WMIJob.JobState <> JobCompleted) then
        WriteLog Format1("ErrorDescription:{0}", WMIJob.ErrorDescription)
        WMIJobCompleted = false
    end if

End Function

'-----------------------------------------------------------------
' Create the console log files.
'-----------------------------------------------------------------
Sub WriteLog(line)
    dim fileStream
    set fileStream = fileSystem.OpenTextFile(".\ADDSCSIContoller.log", 8, true)
    WScript.Echo line
    fileStream.WriteLine line
    fileStream.Close

End Sub


'------------------------------------------------------------------------------
' The string formatting functions to avoid string concatenation.
'------------------------------------------------------------------------------
Function Format2(myString, arg0, arg1)
    Format2 = Format1(myString, arg0)
    Format2 = Replace(Format2, "{1}", arg1)
End Function

'------------------------------------------------------------------------------
' The string formatting functions to avoid string concatenation.
'------------------------------------------------------------------------------
Function Format1(myString, arg0)
    Format1 = Replace(myString, "{0}", arg0)
End Function